VERSION 5.00
Begin VB.UserControl AddInObj 
   ClientHeight    =   1590
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1575
   InvisibleAtRuntime=   -1  'True
   PropertyPages   =   "AddInObj.ctx":0000
   ScaleHeight     =   1590
   ScaleWidth      =   1575
End
Attribute VB_Name = "AddInObj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const ADDIN_E_NONE = 1000
Const ADDIN_E_ORDINARY = 1001
Const ADDIN_E_ATTENTION = 1002
Const ADDIN_E_IMPORTANT = 1003
Const ADDIN_E_VERY_IMPORTANT = 1004
Const ADDIN_E_INFO = 1005
Const ADDIN_E_FAIL = 1006
Const ADDIN_E_MSGBOX_ATTENTION = 1007
Const ADDIN_E_MSGBOX_INFO = 1008
Const ADDIN_E_MSGBOX_FAIL = 1009

Const strIsEnabled = "IsEnabled,"
Const strIsTimerPresent = "IsTimerPresent,"
Const strEnable = "Enable,"
Const strDisable = "Disable,"
Const strShowInStatusLine = "ShowInStatusLine,"
Const strStartTimer = "StartTimer,"
Const strStopTimer = "StopTimer,"

Enum Props
    propIsEnabled = 0
    propIsTimerPresent = 1
    LastProp = 2
End Enum

Enum Methods
    methEnable = 0
    methDisable = 1
    methShowInStatusLine = 2
    methStartTimer = 3
    methStopTimer = 4
    LastMethod = 5
End Enum

Implements IInitDone
Implements ILanguageExtender

Function LoadProperties() As Boolean
    Dim varGet As Variant
    
    varGet = False
    V7Object.Read "Enabled:0", varGet
    boolIsEnabled = varGet
    
    LoadProperties = True
End Function

Sub SaveProperties()
    Dim varGet As Variant
    
    varGet = boolIsEnabled
    V7Object.Write "Enabled", varGet
End Sub

Function TermString(strName As String, Alias As Long) As String
    Dim Ind As Integer
    
    Ind = InStr(strName, ",")
    If (Ind > 0) Then
        If (Alias = 0) Then
            TermString = Left(strName, Ind - 1)
            Else: TermString = Right(strName, Len(strName) - Ind)
        End If
    End If
End Function

Sub IInitDone_Init(ByVal Obj As Object)
    Dim bRet As Boolean

    Set V7Object = Obj
    V7Object.RegisterProfileAs "Sample AddIn Profile Name"
    bRet = LoadProperties()
    If (bRet <> True) Then
        V7Object.AddError ADDIN_E_FAIL, "", "   ", -1
    End If
End Sub

Sub IInitDone_Done()
    SaveProperties
    Set V7Object = Nothing
End Sub

Sub IInitDone_GetInfo(pInfoItems() As Variant)
    pInfoItems(0) = "1000"
End Sub

Sub ILanguageExtender_RegisterExtensionAs(strExtName As String)
    strExtName = "AddInExtension"
End Sub

Sub ILanguageExtender_GetNProps(lProps As Long)
    lProps = LastProp
End Sub

Sub ILanguageExtender_FindProp(ByVal strPropName As String, lPropNum As Long)
    
   lPropNum  = -1

    If (TermString(strIsEnabled, 0) = strPropName) Then lPropNum = 0
    If (TermString(strIsEnabled, 1) = strPropName) Then lPropNum = 0
    If (TermString(strIsTimerPresent, 0) = strPropName) Then lPropNum = 1
    If (TermString(strIsTimerPresent, 1) = strPropName) Then lPropNum = 1

End Sub

Sub ILanguageExtender_GetPropName(ByVal PropPos As Long, ByVal PropAlias As Long, strPropName As String)
    strPropName = ""
    Select Case PropPos
        Case propIsEnabled
            strPropName = TermString(strIsEnabled, PropAlias)
        Case propIsTimerPresent
            strPropName = TermString(strIsTimerPresent, PropAlias)
    End Select
End Sub

Sub ILanguageExtender_GetPropVal(ByVal lPropNum As Long, retVal As Variant)
    retVal = Null
    Select Case lPropNum
        Case propIsEnabled
            If (boolIsEnabled = True) Then
                retVal = 1
                Else: retVal = 0
            End If
        Case propIsTimerPresent
            retVal = 0
    End Select
End Sub

Sub ILanguageExtender_SetPropVal(ByVal lPropNum As Long, retVal As Variant)
    Select Case lPropNum
        Case propIsEnabled
            boolIsEnabled = retVal
    End Select
End Sub

Sub ILanguageExtender_IsPropReadable(ByVal lPropNum As Long, retVal As Long)
    Select Case lPropNum
        Case propIsEnabled
            retVal = True
        Case propIsTimerPresent
            retVal = True
    End Select
End Sub

Sub ILanguageExtender_IsPropWritable(ByVal lPropNum As Long, retVal As Long)
    Select Case lPropNum
        Case propIsEnabled
            retVal = True
        Case propIsTimerPresent
            retVal = False
    End Select
End Sub

Sub ILanguageExtender_GetNMethods(Num As Long)
    Num = LastMethod
End Sub

Sub ILanguageExtender_FindMethod(ByVal strPropName As String, lPropPos As Long)
    lPropPos = -1
    Select Case strPropName
        Case "Enable", ""
            lPropPos = 0
        Case "Disable", ""
            lPropPos = 1
        Case "ShowInStatusLine", ""
            lPropPos = 2
        Case "StartTimer", ""
            lPropPos = 3
        Case "StopTimer", ""
            lPropPos = 4
    End Select
End Sub

Sub ILanguageExtender_GetMethodName(ByVal MethPos As Long, ByVal MethAlias As Long, strMethName As String)
    strMethName = ""
    Select Case MethPos
        Case methEnable
            strMethName = TermString(strEnable, MethAlias)
        Case methDisable
            strMethName = TermString(strDisable, MethAlias)
        Case methShowInStatusLine
            strMethName = TermString(strShowInStatusLine, MethAlias)
        Case methStartTimer
            strMethName = TermString(strStartTimer, MethAlias)
        Case methStopTimer
            strMethName = TermString(strStopTimer, MethAlias)
    End Select
End Sub

Sub ILanguageExtender_GetNParams(ByVal lMethodPos As Long, lMethodParams As Long)
    lMethodParams = 0
    Select Case lMethodPos
        Case methEnable
            lMethodParams = 0
        Case methDisable
            lMethodParams = 0
        Case methShowInStatusLine
            lMethodParams = 1
        Case methStartTimer
            lMethodParams = 0
        Case methStopTimer
            lMethodParams = 0
    End Select
End Sub

Sub ILanguageExtender_GetParamDefValue(ByVal lMethPos As Long, ByVal lParamPos As Long, retVal As Variant)
    ' There is no default value for any parameter
    retVal = Null
End Sub

Sub ILanguageExtender_HasRetVal(ByVal lMethPos As Long, boolRet As Long)
    ' All methods are procedures
    boolRet = False
End Sub

Sub ILanguageExtender_CallAsProc(ByVal iMethodNum As Long, ParamVal() As Variant)
    Dim Start As Single
    
    Select Case iMethodNum
        Case methEnable
            boolIsEnabled = False
        Case methDisable
            boolIsEnabled = True
        Case methShowInStatusLine
            V7Object.SetStatusLine ParamVal(0)
            Start = Timer   ' Set start time.
            Do While Timer < Start + 5
                DoEvents    ' Yield to other processes.
            Loop
        Case methStartTimer
            V7Object.AddError ADDIN_E_FAIL, "", "     ", -1
        Case methStopTimer
            V7Object.AddError ADDIN_E_FAIL, "", "     ", -1
    End Select
End Sub

Sub ILanguageExtender_CallAsFunc(ByVal iMethodNum As Long, retVal As Variant, ParamVal() As Variant)
End Sub

