unit AddInVid;

interface

uses
  Windows, Dialogs, Forms, ActiveX, ComObj, SysUtils, AddInDoc, AddInLib;

resourcestring
    strFileName = 'FileName,';
    strShow = 'Show,';
    strOpenFromFile = 'OpenFromFile,';
    strOpenFromRef = 'OpenFromRef,';

type
TProperties = ( propFileName, LastProp );
TMethods = ( methShow, methOpenFromFile, methOpenFromRef, LastMethod );

  TAddInVideo = class(TComObject,IinitDone,ILanguageExtender)

  public
    FileName: string;
      { Interfaces }
    pConn : IDispatch;
    pErrorLog : IErrorLog;
    pEvent : IAsyncEvent;
    pProfile : IPropertyProfile;
    pExtWndsSupport : IExtWndsSupport;
    pStatusLine : IStatusLine;

  protected

    function LoadProperties: Boolean;
    procedure SaveProperties;
      { This function is useful in ILanguageExtender implementation }
    function TermString(strTerm: string; iAlias: Integer): string;
      {These two methods is convenient way to access function
       parameters from SAFEARRAY vector of variants }
    function GetNParam(var pArray : PSafeArray; lIndex: Integer ): OleVariant;
    procedure PutNParam(var pArray: PSafeArray; lIndex: Integer; var varPut: OleVariant);

      { Interface implementation }
      { IInitDone implementation }
    function Init(const pConnection: IDispatch): HResult; stdcall;
    function Done: HResult; stdcall;
    function GetInfo(var pInfo: PSafeArray{(OleVariant)}): HResult; stdcall;
      { ILanguageExtender implementation }
    function RegisterExtensionAs(var bstrExtensionName: WideString): HResult; stdcall;
    function GetNProps(var plProps: Integer): HResult; stdcall;
    function FindProp(const bstrPropName: WideString; var plPropNum: Integer): HResult; stdcall;
    function GetPropName(lPropNum, lPropAlias: Integer; var pbstrPropName: WideString): HResult; stdcall;
    function GetPropVal(lPropNum: Integer; var pvarPropVal: OleVariant): HResult; stdcall;
    function SetPropVal(lPropNum: Integer; var varPropVal: OleVariant): HResult; stdcall;
    function IsPropReadable(lPropNum: Integer; var pboolPropRead: Integer): HResult; stdcall;
    function IsPropWritable(lPropNum: Integer; var pboolPropWrite: Integer): HResult; stdcall;
    function GetNMethods(var plMethods: Integer): HResult; stdcall;
    function FindMethod(const bstrMethodName: WideString; var plMethodNum: Integer): HResult; stdcall;
    function GetMethodName(lMethodNum, lMethodAlias: Integer; var pbstrMethodName: WideString): HResult; stdcall;
    function GetNParams(lMethodNum: Integer; var plParams: Integer): HResult; stdcall;
    function GetParamDefValue(lMethodNum, lParamNum: Integer; var pvarParamDefValue: OleVariant): HResult; stdcall;
    function HasRetVal(lMethodNum: Integer; var pboolRetValue: Integer): HResult; stdcall;
    function CallAsProc(lMethodNum: Integer; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
    function CallAsFunc(lMethodNum: Integer; var pvarRetValue: OleVariant; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
  end;

const
  Class_AddInVideo: TGUID = '{0787707E-EBE9-11D2-8BF2-008048DA120F}';

implementation

uses ComServ;

function TAddInVideo.LoadProperties: Boolean;
begin

   LoadProperties := True;

end;

procedure TAddInVideo.SaveProperties;
begin

end;

function TAddInVideo.TermString(strTerm: string; iAlias: Integer): string;
var
     iSemicolon: Integer;
begin
     iSemicolon := Pos(',',strTerm);
     if (iAlias = 0) then
       if (iSemicolon = 0) then
         TermString := strTerm
         else
           TermString := Copy(strTerm,1,iSemicolon-1)
       else { iAlias = 1}
         if (iSemicolon = 0) then
           TermString := ''
           else
             TermString := Copy(strTerm,iSemicolon+1,Length(strTerm) - iSemicolon);
end;

function TAddInVideo.GetNParam(var pArray : PSafeArray; lIndex: Integer ): OleVariant;
var varGet : OleVariant;
begin
   SafeArrayGetElement(pArray,lIndex,varGet);
   GetNParam := varGet;
end;

procedure TAddInVideo.PutNParam(var pArray: PSafeArray; lIndex: Integer; var varPut: OleVariant);
begin
  SafeArrayPutElement(pArray,lIndex,varPut);
end;

{ IInitDone interface }

function TAddInVideo.Init(const pConnection: IDispatch): HResult; stdcall;
var iRes : Integer;
    wnd: HWND;
begin
     pConn := pConnection;

     pErrorLog := nil;
     pConnection.QueryInterface(IID_IErrorLog,pErrorLog);

     pEvent := nil;
     pConnection.QueryInterface(IID_IAsyncEvent,pEvent);

     pProfile := nil;
     iRes := pConnection.QueryInterface(IID_IPropertyProfile,pProfile);
     if (iRes = S_OK) then
        begin
             pProfile.RegisterProfileAs('Sample AddIn Profile Name');
             if (LoadProperties() <> True) then
               begin
                 Init := E_FAIL;
                 Exit;
               end;
        end;

     pStatusLine := nil;
     pConnection.QueryInterface(IID_IStatusLine,pStatusLine);

     pExtWndsSupport := nil;
     pConnection.QueryInterface(IID_IExtWndsSupport,pExtWndsSupport);

     pExtWndsSupport.GetAppMainFrame(wnd);
     Application.Handle := wnd;

     Init := S_OK;
end;

function TAddInVideo.Done: HResult; stdcall;
begin

     SaveProperties();

     if (pErrorLog <> nil) then
       pErrorLog._Release();

     if (pEvent <> nil) then
       pEvent._Release();

     if (pProfile <> nil) then
       pProfile._Release();

     if (pStatusLine <> nil) then
       pStatusLine._Release();

     if (pExtWndsSupport <> nil) then
       pExtWndsSupport._Release();

     Done := S_OK;
end;

function TAddInVideo.GetInfo(var pInfo: PSafeArray{(OleVariant)}): HResult; stdcall;
var  varInfo : OleVariant;
begin
     varInfo := '2000';
     PutNParam(pInfo,0,varInfo);
     GetInfo := S_OK;
end;

{ ILanguageExtender interface }

function TAddInVideo.RegisterExtensionAs(var bstrExtensionName: WideString): HResult; stdcall;
begin
     bstrExtensionName := 'AddInVideo';
     RegisterExtensionAs := S_OK;
end;

function TAddInVideo.GetNProps(var plProps: Integer): HResult; stdcall;
begin
     plProps := Integer(LastProp);
     GetNProps := S_OK;
end;

function TAddInVideo.FindProp(const bstrPropName: WideString; var plPropNum: Integer): HResult; stdcall;
begin
     plPropNum := -1;

     if (bstrPropName = TermString(strFileName,0)) then plPropNum := 0;
     if (bstrPropName = TermString(strFileName,1)) then plPropNum := 0;

     if (plPropNum = -1) then
       begin
         FindProp := S_FALSE;
         Exit;
       end;

     FindProp := S_OK;
end;

function TAddInVideo.GetPropName(lPropNum, lPropAlias: Integer; var pbstrPropName: WideString): HResult; stdcall;
begin
     pbstrPropName := '';
     case TProperties(lPropNum) of
          propFileName:
            begin
              pbstrPropName := TermString(strFileName,lPropAlias);
            end;
          else
            begin
               GetPropName := S_FALSE;
               Exit;
            end;
     end;
     GetPropName := S_OK;
end;

function TAddInVideo.GetPropVal(lPropNum: Integer; var pvarPropVal: OleVariant): HResult; stdcall;
begin
     VarClear(pvarPropVal);
     case TProperties(lPropNum) of
          propFileName:
            begin
              pvarPropVal := FileName;
            end;
          else
            begin
               GetPropVal := S_FALSE;
               Exit;
            end;
     end;
     GetPropVal := S_OK;
end;

function TAddInVideo.SetPropVal(lPropNum: Integer; var varPropVal: OleVariant): HResult; stdcall;
begin
     case TProperties(lPropNum) of
          propFileName:
            begin
              FileName := varPropVal;
            end;
          else
            begin
               SetPropVal := S_FALSE;
               Exit;
            end;
     end;
     SetPropVal := S_OK;
end;

function TAddInVideo.IsPropReadable(lPropNum: Integer; var pboolPropRead: Integer): HResult; stdcall;
begin
     IsPropReadable := S_OK;
end;

function TAddInVideo.IsPropWritable(lPropNum: Integer; var pboolPropWrite: Integer): HResult; stdcall;
begin
     IsPropWritable := S_OK;
end;

function TAddInVideo.GetNMethods(var plMethods: Integer): HResult; stdcall;
begin
     plMethods := Integer(LastMethod);
     GetNMethods := S_OK;
end;

function TAddInVideo.FindMethod(const bstrMethodName: WideString; var plMethodNum: Integer): HResult; stdcall;
begin
     plMethodNum := -1;

     if (bstrMethodName = TermString(strShow,0)) then plMethodNum := 0;
     if (bstrMethodName = TermString(strShow,1)) then plMethodNum := 0;
     if (bstrMethodName = TermString(strOpenFromFile,0)) then plMethodNum := 1;
     if (bstrMethodName = TermString(strOpenFromFile,1)) then plMethodNum := 1;
     if (bstrMethodName = TermString(strOpenFromRef,0)) then plMethodNum := 2;
     if (bstrMethodName = TermString(strOpenFromRef,1)) then plMethodNum := 2;

     if (plMethodNum = -1) then
       begin
         FindMethod := S_FALSE;
         Exit;
       end;

     FindMethod := S_OK;

end;

function TAddInVideo.GetMethodName(lMethodNum, lMethodAlias: Integer; var pbstrMethodName: WideString): HResult; stdcall;
begin

     pbstrMethodName := '';

     case TMethods(lMethodNum) of
          methShow:
            begin
              pbstrMethodName := TermString(strShow,lMethodAlias);
            end;
          methOpenFromFile:
            begin
              pbstrMethodName := TermString(strOpenFromFile,lMethodAlias);
            end;
          methOpenFromRef:
            begin
              pbstrMethodName := TermString(strOpenFromRef,lMethodAlias);
            end;
          else
            begin
               GetMethodName := S_FALSE;
               Exit;
            end;
     end;

     GetMethodName := S_OK;

end;

function TAddInVideo.GetNParams(lMethodNum: Integer; var plParams: Integer): HResult; stdcall;
begin

     plParams := 0;

     case TMethods(lMethodNum) of
          methShow:
            begin
              plParams := 0;
            end;
          methOpenFromFile:
            begin
              plParams := 0;
            end;
          methOpenFromRef:
            begin
              plParams := 0;
            end;
          else
            begin
               GetNParams := S_FALSE;
               Exit;
            end;
     end;

     GetNParams := S_OK;

end;

function TAddInVideo.GetParamDefValue(lMethodNum, lParamNum: Integer; var pvarParamDefValue: OleVariant): HResult; stdcall;
begin
       { Ther is no default value for any parameter }
     VarClear(pvarParamDefValue);
     GetParamDefValue := S_OK;
end;

function TAddInVideo.HasRetVal(lMethodNum: Integer; var pboolRetValue: Integer): HResult; stdcall;
begin
     pboolRetValue := 0;
     HasRetVal := S_OK;
end;

function TAddInVideo.CallAsProc(lMethodNum: Integer; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
var wnd: HWND;
    cntr: IDispatch;
    rct: RECT;
    form: TAddInDoc;
    dlgOpen: TOpenDialog;
    obj,elem: Variant;
    ret: Integer;
begin

     case TMethods(lMethodNum) of
          methShow:
            begin
                form := TAddInDoc.Create(nil);
                rct.left := 10;
                rct.top := 10;
                rct.right := form.Width;
                rct.bottom := form.Height;
                pExtWndsSupport.CreateAddInWindow('AddIn.AddInDoc', '  ', 0, 0, rct, 0, wnd, cntr);
                obj := cntr;
                obj.SetFileName(FileName);
                obj.Play;
                cntr._Release();
            end;
          methOpenFromFile:
            begin
                dlgOpen := TOpenDialog.Create(nil);
                dlgOpen.Filter := ' AVI (*.avi)|*.avi';
                if (dlgOpen.Execute() = TRUE) then
                    pEvent.ExternalEvent('AddInVideo', 'ShowClip', dlgOpen.FileName)
            end;
          methOpenFromRef:
            begin
                obj := pConn;
                obj := obj.AppDispatch;
                obj := obj.EvalExpr('(".")');
                ret := obj.('    ','');
                if (ret = 1) then
                    begin
                        elem := obj.;
                        pEvent.ExternalEvent('AddInVideo', 'ShowClip', Trim(elem.));
                    end;
            end;
          else
            begin
               CallAsProc := S_FALSE;
               Exit;
            end;
     end;

     CallAsProc := S_OK;
end;

function TAddInVideo.CallAsFunc(lMethodNum: Integer; var pvarRetValue: OleVariant; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
begin
     CallAsFunc := S_FALSE;
end;

initialization
  TComObjectFactory.Create(ComServer, TAddInVideo, Class_AddInVideo,
    'AddInVideo', '', ciMultiInstance, tmApartment);
end.
