// AddIn.cpp

#include "stdafx.h"
#include <afxdlgs.h>
#include "AddIn.h"

//  2       
//       ,   
//     1 ,  ID  ,    
//         ,  ,  
//  ,       
#define FIRST_PROPERTY_ID IDS_TERM_PROP_FILENAME // first property name string ID 
#define LAST_PROPERTY_ID  IDS_TERM_PROP_FILENAME+1 // last property name string ID + 1

//  2       
//       ,   
//     1 ,  ID  ,    
//         ,  ,  
//  ,       
#define FIRST_METHOD_ID IDS_TERM_METH_SHOW // first method name string ID 
#define LAST_METHOD_ID  IDS_TERM_METH_SELFROMREF + 1 // last method name string ID + 1

/////////////////////////////////////////////////////////////////////////////
// CAddIn

BOOL CAddIn::LoadProperties()
{  
    return TRUE;
}

void CAddIn::SaveProperties()
{
}
  
  // This function is useful in ILanguageExtender implementation
CString CAddIn::TermString(UINT uiResID,long nAlias)
{
  CString cs;
  cs.LoadString(uiResID);
  int iInd = cs.Find(',');
  if (iInd == -1)
    return cs;
  switch(nAlias)
    { case 0: // First language
        return cs.Left(iInd);
      case 1: // Second language
        return cs.Right(cs.GetLength()-iInd-1);
      default:
        return CString("");
    };
}

  /* 
     These two methods is convenient way to access function 
     parameters from SAFEARRAY vector of variants
  */
VARIANT CAddIn::GetNParam(SAFEARRAY *pArray,long lIndex)
{
  ASSERT(pArray);
  ASSERT(pArray->fFeatures | FADF_VARIANT);
  
  VARIANT vt;
  HRESULT hRes = SafeArrayGetElement(pArray,&lIndex,&vt);
  ASSERT(hRes == S_OK);

  return vt;
}

void CAddIn::PutNParam(SAFEARRAY *pArray,long lIndex,VARIANT vt)
{
  ASSERT(pArray);
  ASSERT(pArray->fFeatures | FADF_VARIANT);
  
  HRESULT hRes = SafeArrayPutElement(pArray,&lIndex,&vt);
  ASSERT(hRes == S_OK);
}

/////////////////////////////////////////////////////////////////////////////
// IInitDone

STDMETHODIMP CAddIn::Init(IDispatch *pConnection)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
    
    m_iDispatch = pConnection;
    
    m_iErrorLog = NULL;
    pConnection->QueryInterface(IID_IErrorLog,(void **)&m_iErrorLog);
    
    CString csProfileName = "AddIn Profile Name";
    m_iProfile = NULL;
    pConnection->QueryInterface(IID_IPropertyProfile,(void **)&m_iProfile);
    m_iProfile->RegisterProfileAs(csProfileName.AllocSysString());

    m_iStatusLine = NULL;
    pConnection->QueryInterface(IID_IStatusLine,(void **)&m_iStatusLine);

    m_iAsyncEvent = NULL;
    pConnection->QueryInterface(IID_IAsyncEvent,(void **)&m_iAsyncEvent);

    m_iExtWndsSupport = NULL;
    pConnection->QueryInterface(IID_IExtWndsSupport,(void **)&m_iExtWndsSupport);

    if (LoadProperties() == FALSE) return E_FAIL;
    
	return S_OK;
}

STDMETHODIMP CAddIn::Done()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    SaveProperties();

    if (m_iExtWndsSupport) m_iExtWndsSupport->Release();
    if (m_iStatusLine) m_iStatusLine->Release();
    if (m_iProfile) m_iProfile->Release();
    if (m_iErrorLog) m_iErrorLog->Release();
    if (m_iAsyncEvent) m_iAsyncEvent->Release();
    
	return S_OK;
}

STDMETHODIMP CAddIn::GetInfo(SAFEARRAY **pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

      // Component should put supported component technology version 
      // in VARIANT at index 0     
    long lInd = 0;
    VARIANT varVersion;
    V_VT(&varVersion) = VT_I4;
      // This component supports 2.0 version
    V_I4(&varVersion) = 2000;
    SafeArrayPutElement(*pInfo,&lInd,&varVersion);
    
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// ILanguageExtender

STDMETHODIMP CAddIn::RegisterExtensionAs(BSTR *bstrExtensionName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CString csExtenderName = "AddInVideo";
    *bstrExtensionName = csExtenderName.AllocSysString();

	return NULL;
}

STDMETHODIMP CAddIn::GetNProps(long *plProps)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    *plProps = LastProp;

	return S_OK;
}

STDMETHODIMP CAddIn::FindProp(BSTR bstrPropName,long *plPropNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
    USES_CONVERSION;

	*plPropNum = -1;

    CString csPropName = OLE2T(bstrPropName); 
	for(long i = FIRST_PROPERTY_ID ; i < LAST_PROPERTY_ID ; i++) {
		if(TermString(i, 0) == csPropName) {
			*plPropNum = i - FIRST_PROPERTY_ID ;
			break ;
		} ;
		if(TermString(i, 1) == csPropName) {
			*plPropNum = i - FIRST_PROPERTY_ID ;
			break ;
		} ;
	} ;

    if (*plPropNum == -1) return S_FALSE;

	return S_OK;
}

STDMETHODIMP CAddIn::GetPropName(long lPropNum,long lPropAlias,BSTR *pbstrPropName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CString csPropName = ""; 
    if((lPropNum >= 0) && ((FIRST_PROPERTY_ID + lPropNum) < LAST_PROPERTY_ID)) {
        csPropName = TermString(FIRST_PROPERTY_ID + lPropNum,lPropAlias);
    };
    if (csPropName.IsEmpty()) return S_FALSE;
    *pbstrPropName = csPropName.AllocSysString();
	return S_OK;
}

STDMETHODIMP CAddIn::GetPropVal(long lPropNum,VARIANT *pvarPropVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    VariantInit(pvarPropVal);
    switch(lPropNum)
      { 
        case propFileName:
            {
                V_VT(pvarPropVal) = VT_BSTR;
                V_BSTR(pvarPropVal) = m_csFileName.AllocSysString();
            };
            break ;
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::SetPropVal(long lPropNum,VARIANT *pvarPropVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;

    switch(lPropNum)
      { 
        case propFileName:
            {
                m_csFileName = OLE2T(V_BSTR(pvarPropVal));
            }
            break;
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::IsPropReadable(long lPropNum,BOOL *pboolPropRead)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    switch(lPropNum)
      { 
        case propFileName:
            *pboolPropRead = TRUE ;
            break ;
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::IsPropWritable(long lPropNum,BOOL *pboolPropWrite)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    switch(lPropNum)
      { 
        case propFileName:
            *pboolPropWrite = TRUE ;
            break ;
        default:
          return S_FALSE;
      }

    return S_OK;
}

STDMETHODIMP CAddIn::GetNMethods(long *plMethods)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    *plMethods = LastMethod;

	return S_OK;
}

STDMETHODIMP CAddIn::FindMethod(BSTR bstrMethodName,long *plMethodNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    USES_CONVERSION;

    *plMethodNum = -1;
    CString csPropName = OLE2T(bstrMethodName);

	for(long i = FIRST_METHOD_ID ; i < LAST_METHOD_ID ; i++) {
		if(TermString(i, 0) == csPropName) {
			*plMethodNum = i - FIRST_METHOD_ID;
			break ;
		}
		if(TermString(i, 1) == csPropName) {
			*plMethodNum = i - FIRST_METHOD_ID;
			break ;
		}
	} ;

	return S_OK;
}

STDMETHODIMP CAddIn::GetMethodName(long lMethodNum,long lMethodAlias,BSTR *pbstrMethodName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    CString csMethodName = "";
    if((lMethodNum >= 1) && ((lMethodNum + FIRST_METHOD_ID) < LAST_METHOD_ID)) {
          csMethodName = TermString(lMethodNum + FIRST_METHOD_ID, lMethodAlias);
    };
    *pbstrMethodName = csMethodName.AllocSysString();
    if (csMethodName.IsEmpty()) return S_FALSE;

	return S_OK;
}

STDMETHODIMP CAddIn::GetNParams(long lMethodNum,long *plParams)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    *plParams = 0;
    switch(lMethodNum)
      { 
        case methShow:
        case methSelFromFile:
        case methSelFromRef:
            break;
        default:
          return S_FALSE;
      }
    
	return S_OK;
}

STDMETHODIMP CAddIn::GetParamDefValue(long lMethodNum,long lParamNum,VARIANT *pvarParamDefValue)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    VariantInit(pvarParamDefValue);
    switch(lMethodNum)
      { 
        case methShow:
        case methSelFromFile:
        case methSelFromRef:
            break;
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::HasRetVal(long lMethodNum,BOOL *pboolRetValue)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    switch(lMethodNum)
      { 
        case methShow:
        case methSelFromFile:
        case methSelFromRef:
            *pboolRetValue = FALSE;
            break;
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::CallAsProc(long lMethodNum,SAFEARRAY **paParams)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	USES_CONVERSION;

    switch(lMethodNum)
      { 
        case methShow:
            {
                RECT rct = { 10,10,200,200 };
                CString csProgID = "AddIn.ActDoc";
                CString csTitle = "  ";
                HWND hWnd;
                IDispatch *pDisp;
                m_iExtWndsSupport->CreateAddInWindow(csProgID.AllocSysString(),
                                                            csTitle.AllocSysString(),
                                                            0,0,
                                                            &rct,
                                                            0,
                                                            &hWnd,
                                                            &pDisp);

                COleDispatchDriver drvMain(pDisp,FALSE);

                DISPID id;
                BYTE bTypes[2] = { VT_BSTR,0 };
                BSTR bscFName = T2OLE(m_csFileName);
                BSTR bcs = T2OLE("SetFileName");
                BSTR *arNames = &bcs;
                pDisp->GetIDsOfNames(IID_NULL,arNames,1,MAKELCID(MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),SORT_DEFAULT),&id);
                drvMain.InvokeHelper(id,DISPATCH_METHOD,VT_EMPTY,NULL,bTypes,bscFName);

                CString csPlay("Play");
                BSTR bcsPlay = csPlay.AllocSysString();
                arNames = &bcsPlay;
                pDisp->GetIDsOfNames(IID_NULL,arNames,1,MAKELCID(MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),SORT_DEFAULT),&id);
                drvMain.InvokeHelper(id,DISPATCH_METHOD,VT_EMPTY,NULL,NULL);

                pDisp->Release();
            }
            break;
        case methSelFromFile:
            OnSelFromFile();
            break;
        case methSelFromRef:
            OnSelFromRef();
            break;
        default:
          return S_FALSE;
      }
    
	return S_OK;
}

STDMETHODIMP CAddIn::CallAsFunc(long lMethodNum,VARIANT *pvarRetValue,SAFEARRAY **paParams)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	return S_OK;
}

void CAddIn::OnSelFromRef() 
{
    USES_CONVERSION;
    
    COleDispatchDriver drvMain(m_iDispatch,FALSE);

    IDispatch *pDisp;
    BSTR bcs = T2OLE("AppDispatch");
    BSTR *arNames = &bcs;
    DISPID id;
    m_iDispatch->GetIDsOfNames(IID_NULL,arNames,1,MAKELCID(MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),SORT_DEFAULT),&id);
    drvMain.InvokeHelper(id,DISPATCH_PROPERTYGET,VT_DISPATCH,&pDisp,NULL);
    
    COleDispatchDriver drvApp(pDisp,TRUE);

    bcs = T2OLE("EvalExpr");
    pDisp->GetIDsOfNames(IID_NULL,arNames,1,MAKELCID(MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),SORT_DEFAULT),&id);
    CString csRef("CreateObject(\".\")");
    BSTR bcsRef = T2OLE(csRef);
    BYTE bTypes[2] = { VT_BSTR,0 };
    IDispatch *pRef;
    drvApp.InvokeHelper(id,DISPATCH_METHOD,VT_DISPATCH,&pRef,bTypes,bcsRef);

    COleDispatchDriver drvRef(pRef,TRUE);

    bcs = T2OLE("Choose");
    pRef->GetIDsOfNames(IID_NULL,arNames,1,MAKELCID(MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),SORT_DEFAULT),&id);
    CString csTitle("    ");
    BSTR bcsTitle = T2OLE(csTitle);
    BOOL bRet;
    drvRef.InvokeHelper(id,DISPATCH_METHOD,VT_BOOL,&bRet,bTypes,bcsTitle);

    if (!bRet) return;

    bcs = T2OLE("");
    pRef->GetIDsOfNames(IID_NULL,arNames,1,MAKELCID(MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),SORT_DEFAULT),&id);
    IDispatch *pElem;
    drvRef.InvokeHelper(id,DISPATCH_METHOD,VT_DISPATCH,&pElem,bTypes,NULL);

    COleDispatchDriver drvElem(pElem,TRUE);
    
    bcs = T2OLE("");
    pElem->GetIDsOfNames(IID_NULL,arNames,1,MAKELCID(MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),SORT_DEFAULT),&id);
    CString path;
    drvElem.InvokeHelper(id,DISPATCH_PROPERTYGET,VT_BSTR,&path,bTypes,NULL);
    path.TrimRight();

    BSTR bstrSrc,bstrMsg,bstrData;
    bstrSrc = T2OLE("AddInVideo");
    bstrMsg = T2OLE("ShowClip");
    bstrData = T2OLE(path);
    m_iAsyncEvent->ExternalEvent(bstrSrc,bstrMsg,bstrData);
}

void CAddIn::OnSelFromFile()
{
    USES_CONVERSION;
    
    HWND hParent;
    m_iExtWndsSupport->GetAppMDIFrame(&hParent);
    CFileDialog	dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Clip (*.avi)|*.avi| (*.mov)|*.mov||",CWnd::FromHandle(hParent));
    int iRet = dlg.DoModal();
    if (iRet != IDOK) return;

    CString path = dlg.GetPathName();
    BSTR bstrSrc,bstrMsg,bstrData;
    bstrSrc = T2OLE("AddInVideo");
    bstrMsg = T2OLE("ShowClip");
    bstrData = T2OLE(path);
    m_iAsyncEvent->ExternalEvent(bstrSrc,bstrMsg,bstrData);
}
