unit AddInObj;

interface

uses ComServ, ComObj, ActiveX, AddInLib, PropPage,
SysUtils, Windows, Messages, Classes, Graphics, Controls, StdCtrls,
  ExtCtrls, Forms, StdVcl, AxCtrls;

const
            { This GUID should be changed}
     CLSID_AddInObject : TGUID = '{803C78D2-25BB-11d1-A4CB-004095E1DAEA}';

type

TProperties = ( LastProp );
TMethods = ( LastMethod );

TAddInObject = class (TComObject, IInitDone, IDispatch,
                      ISpecifyPropertyPages,ILanguageExtender)
      { Attributes }

      { Interfaces }
    pErrorLog : IErrorLog;
    pEvent : IAsyncEvent;
    pProfile : IPropertyProfile;
    pStatusLine : IStatusLine;

    function LoadProperties: Boolean;
    procedure SaveProperties;
      { This function is useful in ILanguageExtender implementation }
    function TermString(strTerm: string; iAlias: Integer): string;
      {These two methods is convenient way to access function
       parameters from SAFEARRAY vector of variants }
    function GetNParam(var pArray : PSafeArray; lIndex: Integer ): OleVariant;
    procedure PutNParam(var pArray: PSafeArray; lIndex: Integer; var varPut: OleVariant);

      { Interface implementation }
      { IInitDone implementation }
    function Init(pConnection: IDispatch): HResult; stdcall;
    function Done: HResult; stdcall;
    function GetInfo(var pInfo: PSafeArray{(OleVariant)}): HResult; stdcall;
      { ISpecifyPropertyPages implementation }
    function GetPages(out Pages: TCAGUID) : HResult; stdcall;
      { ILanguageExtender implementation }
    function RegisterExtensionAs(var bstrExtensionName: WideString): HResult; stdcall;
    function GetNProps(var plProps: Integer): HResult; stdcall;
    function FindProp(const bstrPropName: WideString; var plPropNum: Integer): HResult; stdcall;
    function GetPropName(lPropNum, lPropAlias: Integer; var pbstrPropName: WideString): HResult; stdcall;
    function GetPropVal(lPropNum: Integer; var pvarPropVal: OleVariant): HResult; stdcall;
    function SetPropVal(lPropNum: Integer; var varPropVal: OleVariant): HResult; stdcall;
    function IsPropReadable(lPropNum: Integer; var pboolPropRead: Integer): HResult; stdcall;
    function IsPropWritable(lPropNum: Integer; var pboolPropWrite: Integer): HResult; stdcall;
    function GetNMethods(var plMethods: Integer): HResult; stdcall;
    function FindMethod(const bstrMethodName: WideString; var plMethodNum: Integer): HResult; stdcall;
    function GetMethodName(lMethodNum, lMethodAlias: Integer; var pbstrMethodName: WideString): HResult; stdcall;
    function GetNParams(lMethodNum: Integer; var plParams: Integer): HResult; stdcall;
    function GetParamDefValue(lMethodNum, lParamNum: Integer; var pvarParamDefValue: OleVariant): HResult; stdcall;
    function HasRetVal(lMethodNum: Integer; var pboolRetValue: Integer): HResult; stdcall;
    function CallAsProc(lMethodNum: Integer; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
    function CallAsFunc(lMethodNum: Integer; var pvarRetValue: OleVariant; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;

            { IDispatch }
    function GetIDsOfNames(const IID: TGUID; Names: Pointer;
      NameCount, LocaleID: Integer; DispIDs: Pointer): HResult; virtual; stdcall;
    function GetTypeInfo(Index, LocaleID: Integer; out TypeInfo): HResult; virtual; stdcall;
    function GetTypeInfoCount(out Count: Integer): HResult; virtual; stdcall;
    function Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
      Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult; virtual; stdcall;

end;

implementation

function TAddInObject.LoadProperties: Boolean;
begin

   LoadProperties := True;

end;

procedure TAddInObject.SaveProperties;
begin

end;

function TAddInObject.TermString(strTerm: string; iAlias: Integer): string;
var
     iSemicolon: Integer;
begin
     iSemicolon := Pos(',',strTerm);
     if (iAlias = 0) then
       if (iSemicolon = 0) then
         TermString := strTerm
         else
           TermString := Copy(strTerm,1,iSemicolon-1)
       else { iAlias = 1}
         if (iSemicolon = 0) then
           TermString := ''
           else
             TermString := Copy(strTerm,iSemicolon+1,Length(strTerm) - iSemicolon);
end;

function TAddInObject.GetNParam(var pArray : PSafeArray; lIndex: Integer ): OleVariant;
var varGet : OleVariant;
begin
   SafeArrayGetElement(@pArray,lIndex,varGet);
   GetNParam := varGet;
end;

procedure TAddInObject.PutNParam(var pArray: PSafeArray; lIndex: Integer; var varPut: OleVariant);
begin
  SafeArrayPutElement(@pArray,lIndex,varPut);
end;

{ IInitDone interface }

function TAddInObject.Init(pConnection: IDispatch): HResult; stdcall;
var iRes : Integer;
begin

     pErrorLog := nil;
     pConnection.QueryInterface(IID_IErrorLog,pErrorLog);

     pEvent := nil;
     pConnection.QueryInterface(IID_IAsyncEvent,pEvent);

     pProfile := nil;
     iRes := pConnection.QueryInterface(IID_IPropertyProfile,pProfile);
     if (iRes = S_OK) then
        begin
             pProfile.RegisterProfileAs('Sample AddIn Profile Name');
             if (LoadProperties() <> True) then
               begin
                 Init := E_FAIL;
                 Exit;
               end;
        end;

     pStatusLine := nil;
     pConnection.QueryInterface(IID_IStatusLine,pStatusLine);

     Init := S_OK;
end;

function TAddInObject.Done: HResult; stdcall;
begin

     if (pErrorLog <> nil) then
       pErrorLog._Release();

     if (pEvent <> nil) then
       pEvent._Release();

     if (pProfile <> nil) then
       pProfile._Release();

     if (pStatusLine <> nil) then
       pStatusLine._Release();

     Done := S_OK;
end;

function TAddInObject.GetInfo(var pInfo: PSafeArray{(OleVariant)}): HResult; stdcall;
var  varInfo : OleVariant;
begin
     varInfo := '2000';
     PutNParam(pInfo,0,varInfo);
     GetInfo := S_OK;
end;

{ ISpecifyPropertyPages interface }

function TAddInObject.GetPages(out Pages: TCAGUID) : HResult; stdcall;
begin
     Pages.cElems := 1;
     Pages.pElems := CoTaskMemAlloc(SizeOf(TGUID));
     (Pages.pElems)[0] := Class_AddInPropPage;
     GetPages := S_OK;
end;

{ ILanguageExtender interface }

function TAddInObject.RegisterExtensionAs(var bstrExtensionName: WideString): HResult; stdcall;
begin

	  { You may delete next lines and add your own implementation code here }

      { Name of extension should be changed avoiding conflicts }
     bstrExtensionName := 'AddInExtension';
     RegisterExtensionAs := S_OK;
end;

function TAddInObject.GetNProps(var plProps: Integer): HResult; stdcall;
begin

	  { You may delete next lines and add your own implementation code here }

     plProps := Integer(LastProp);
     GetNProps := S_OK;
end;

function TAddInObject.FindProp(const bstrPropName: WideString; var plPropNum: Integer): HResult; stdcall;
begin
     plPropNum := -1;

     { Assign proper value to plPropNum if property named bstrPropName is found }

     if (plPropNum = -1) then
       begin
         FindProp := S_FALSE;
         Exit;
       end;

     FindProp := S_OK;
end;

function TAddInObject.GetPropName(lPropNum, lPropAlias: Integer; var pbstrPropName: WideString): HResult; stdcall;
begin
     pbstrPropName := '';
     case TProperties(lPropNum) of
        {
          Differentiate cases here:
            Prop1: ...
            Prop2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastProp:
          else
            GetPropName := S_FALSE;
            Exit;
     end;

     GetPropName := S_OK;
end;

function TAddInObject.GetPropVal(lPropNum: Integer; var pvarPropVal: OleVariant): HResult; stdcall;
begin

     VarClear(pvarPropVal);
     case TProperties(lPropNum) of
        {
          Differentiate cases here:
            Prop1: ...
            Prop2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastProp:
          else
            GetPropVal := S_FALSE;
            Exit;
     end;

     GetPropVal := S_OK;

end;

function TAddInObject.SetPropVal(lPropNum: Integer; var varPropVal: OleVariant): HResult; stdcall;
begin

     case TProperties(lPropNum) of
        {
          Differentiate cases here:
            Prop1: ...
            Prop2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastProp:
          else
            SetPropVal := S_FALSE;
            Exit;
     end;

     SetPropVal := S_OK;

end;

function TAddInObject.IsPropReadable(lPropNum: Integer; var pboolPropRead: Integer): HResult; stdcall;
begin

     case TProperties(lPropNum) of
        {
          Differentiate cases here:
            Prop1: ...
            Prop2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastProp:
          else
            IsPropReadable := S_FALSE;
            Exit;
     end;

     IsPropReadable := S_OK;

end;

function TAddInObject.IsPropWritable(lPropNum: Integer; var pboolPropWrite: Integer): HResult; stdcall;
begin
     case TProperties(lPropNum) of
        {
          Differentiate cases here:
            Prop1: ...
            Prop2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastProp:
          else
            IsPropWritable := S_FALSE;
            Exit;
     end;

     IsPropWritable := S_OK;

end;

function TAddInObject.GetNMethods(var plMethods: Integer): HResult; stdcall;
begin

   { You may delete next lines and add your own implementation code here }

     plMethods := Integer(LastMethod);
     GetNMethods := S_OK;

end;

function TAddInObject.FindMethod(const bstrMethodName: WideString; var plMethodNum: Integer): HResult; stdcall;
begin
     plMethodNum := -1;

    { Assign proper value to plMethodNum if method named bstrMethodName is found }

     if (plMethodNum = -1) then
       begin
         FindMethod := S_FALSE;
         Exit;
       end;

     FindMethod := S_OK;

end;

function TAddInObject.GetMethodName(lMethodNum, lMethodAlias: Integer; var pbstrMethodName: WideString): HResult; stdcall;
begin

     pbstrMethodName := '';

     case TMethods(lMethodNum) of
        {
          Differentiate cases here:
            Method1: ...
            Method2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastMethod:
          else
            begin
               GetMethodName := S_FALSE;
               Exit;
            end;
     end;

     GetMethodName := S_OK;

end;

function TAddInObject.GetNParams(lMethodNum: Integer; var plParams: Integer): HResult; stdcall;
begin

     plParams := 0;

     case TMethods(lMethodNum) of
        {
          Differentiate cases here:
            Method1: ...
            Method2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastMethod:
          else
            begin
               GetNParams := S_FALSE;
               Exit;
            end;
     end;

     GetNParams := S_OK;

end;

function TAddInObject.GetParamDefValue(lMethodNum, lParamNum: Integer; var pvarParamDefValue: OleVariant): HResult; stdcall;
begin

     VarClear(pvarParamDefValue);
     case TMethods(lMethodNum) of
        {
          Differentiate cases here:
            Method1: ...
            Method2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastMethod:
          else
            begin
               GetParamDefValue := S_FALSE;
               Exit;
            end;
     end;

     GetParamDefValue := S_OK;

end;

function TAddInObject.HasRetVal(lMethodNum: Integer; var pboolRetValue: Integer): HResult; stdcall;
begin

     case TMethods(lMethodNum) of
        {
          Differentiate cases here:
            Method1: ...
            Method2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastMethod:
          else
            begin
               HasRetVal := S_FALSE;
               Exit;
            end;
     end;

     HasRetVal := S_OK;

end;

function TAddInObject.CallAsProc(lMethodNum: Integer; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
begin

     case TMethods(lMethodNum) of
        {
          Differentiate cases here:
            Method1: ...
            Method2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastMethod:
          else
            begin
               CallAsProc := S_FALSE;
               Exit;
            end;
     end;

     CallAsProc := S_OK;
end;

function TAddInObject.CallAsFunc(lMethodNum: Integer; var pvarRetValue: OleVariant; var paParams: PSafeArray{(OleVariant)}): HResult; stdcall;
begin

     case TMethods(lMethodNum) of
        {
          Differentiate cases here:
            Method1: ...
            Method2: ...
             ...
        }
        { This line is for successful build only and should be removed}
          LastMethod:
          else
            begin
               CallAsFunc := S_FALSE;
               Exit;
            end;
     end;

     CallAsFunc := S_FALSE;
end;

function TAddInObject.GetIDsOfNames(const IID: TGUID; Names: Pointer;
  NameCount, LocaleID: Integer; DispIDs: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.GetTypeInfo(Index, LocaleID: Integer;
  out TypeInfo): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.GetTypeInfoCount(out Count: Integer): HResult;
begin
  Result := E_NOTIMPL;
end;

function TAddInObject.Invoke(DispID: Integer; const IID: TGUID; LocaleID: Integer;
  Flags: Word; var Params; VarResult, ExcepInfo, ArgErr: Pointer): HResult;
begin
  Result := E_NOTIMPL;
end;

initialization

ComServer.SetServerName('AddIn');
TComObjectFactory.Create(ComServer,TAddInObject,CLSID_AddInObject,
                 'AddIn','V7 AddIn 2.0',ciSingleInstance);

end.
