<ComClass(AddInObj.ClassId, AddInObj.InterfaceId, AddInObj.EventsId)> _
Public Class AddInObj
    Implements AddInLib.IInitDone
    Implements AddInLib.ILanguageExtender
#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "BFF6CCD3-2FB2-4431-BCB1-DA343C39D55F"
    Public Const InterfaceId As String = "E9ECC063-5785-48D3-809B-E79127F72999"
    Public Const EventsId As String = "853CD363-EBF4-4563-9192-89A22E35CD8D"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub

    Const ADDIN_E_NONE = 1000
    Const ADDIN_E_ORDINARY = 1001
    Const ADDIN_E_ATTENTION = 1002
    Const ADDIN_E_IMPORTANT = 1003
    Const ADDIN_E_VERY_IMPORTANT = 1004
    Const ADDIN_E_INFO = 1005
    Const ADDIN_E_FAIL = 1006
    Const ADDIN_E_MSGBOX_ATTENTION = 1007
    Const ADDIN_E_MSGBOX_INFO = 1008
    Const ADDIN_E_MSGBOX_FAIL = 1009

    Dim V7Object As Object

    Enum Props
        LastProp
    End Enum

    Enum Methods
        LastMethod
    End Enum

    Function LoadProperties() As Boolean
        LoadProperties = True
    End Function

    Sub SaveProperties()
    End Sub

    Function TermString(ByVal strName As String, ByVal strAlias As Long) As String
        Dim Ind As Integer

        Ind = strName.IndexOf(",")
        If (Ind > 0) Then
            If (strAlias = 0) Then
                TermString = strName.Substring(0, Ind - 1)
            Else : TermString = strName.Substring(strName.Length() - Ind)
            End If
        End If
    End Function

    Overridable Overloads Sub Init(ByVal Obj As Object) Implements AddInLib.IInitDone.Init
        Dim bRet As Boolean

        V7Object = Obj
        V7Object.RegisterProfileAs("Sample AddIn Profile Name")
        bRet = LoadProperties()
        If (bRet <> True) Then
            V7Object.AddError(ADDIN_E_FAIL, "", "   ", -1)
        End If
    End Sub

    Overridable Overloads Sub Done() Implements AddInLib.IInitDone.Done
        SaveProperties()
        V7Object = Nothing
        GC.Collect()
        GC.WaitForPendingFinalizers()
    End Sub

    Overridable Overloads Sub GetInfo(ByRef pInfoItems As System.Array) Implements AddInLib.IInitDone.GetInfo
        pInfoItems(0) = "1000"
    End Sub

    Overridable Overloads Sub RegisterExtensionAs(ByRef strExtName As String) Implements AddInLib.ILanguageExtender.RegisterExtensionAs
        strExtName = "AddInExtension"
    End Sub

    Overridable Overloads Sub GetNProps(ByRef lProps As Integer) Implements AddInLib.ILanguageExtender.GetNProps
        lProps = Props.LastProp
    End Sub

    Overridable Overloads Sub FindProp(ByVal strPropName As String, ByRef lPropNum As Integer) Implements AddInLib.ILanguageExtender.FindProp
        lPropNum = -1
    End Sub

    Overridable Overloads Sub GetPropName(ByVal PropPos As Integer, ByVal PropAlias As Integer, ByRef strPropName As String) Implements AddInLib.ILanguageExtender.GetPropName
        strPropName = ""
    End Sub

    Overridable Overloads Sub GetPropVal(ByVal lPropNum As Integer, ByRef retVal As Object) Implements AddInLib.ILanguageExtender.GetPropVal
        retVal = Nothing
    End Sub

    Overridable Overloads Sub SetPropVal(ByVal lPropNum As Integer, ByRef retVal As Object) Implements AddInLib.ILanguageExtender.SetPropVal
    End Sub

    Overridable Overloads Sub IsPropReadable(ByVal lPropNum As Integer, ByRef retVal As Integer) Implements AddInLib.ILanguageExtender.IsPropReadable
    End Sub

    Overridable Overloads Sub IsPropWritable(ByVal lPropNum As Integer, ByRef retVal As Integer) Implements AddInLib.ILanguageExtender.IsPropWritable
    End Sub

    Overridable Overloads Sub GetNMethods(ByRef Num As Integer) Implements AddInLib.ILanguageExtender.GetNMethods
        Num = Methods.LastMethod
    End Sub

    Overridable Overloads Sub FindMethod(ByVal strMethName As String, ByRef lMethPos As Integer) Implements AddInLib.ILanguageExtender.FindMethod
        lMethPos = -1
    End Sub

    Overridable Overloads Sub GetMethodName(ByVal MethPos As Integer, ByVal MethAlias As Integer, ByRef strMethName As String) Implements AddInLib.ILanguageExtender.GetMethodName
        strMethName = ""
    End Sub

    Overridable Overloads Sub GetNParams(ByVal lMethodPos As Integer, ByRef lMethodParams As Integer) Implements AddInLib.ILanguageExtender.GetNParams
        lMethodParams = 0
    End Sub

    Overridable Overloads Sub GetParamDefValue(ByVal lMethPos As Integer, ByVal lParamPos As Integer, ByRef retVal As Object) Implements AddInLib.ILanguageExtender.GetParamDefValue
        ' There is no default value for any parameter
        retVal = Nothing
    End Sub

    Overridable Overloads Sub HasRetVal(ByVal lMethPos As Integer, ByRef boolRet As Integer) Implements AddInLib.ILanguageExtender.HasRetVal
        ' All methods are procedures
        boolRet = False
    End Sub

    Overridable Overloads Sub CallAsProc(ByVal iMethodNum As Integer, ByRef ParamVal As System.Array) Implements AddInLib.ILanguageExtender.CallAsProc
    End Sub

    Overridable Overloads Sub CallAsFunc(ByVal iMethodNum As Integer, ByRef retVal As Object, ByRef ParamVal As System.Array) Implements AddInLib.ILanguageExtender.CallAsFunc
    End Sub

End Class


