// AddIn.cpp

#include "stdafx.h"
#include "AddIn.h"

/////////////////////////////////////////////////////////////////////////////
// CAddIn

BOOL CAddIn::LoadProperties()
{  
    return TRUE;
}

void CAddIn::SaveProperties()
{
}
  
  // This function is useful in ILanguageExtender implementation
CString CAddIn::TermString(UINT uiResID,long nAlias)
{
  CString cs;
  cs.LoadString(uiResID);
  int iInd = cs.Find(',');
  if (iInd == -1)
    return cs;
  switch(nAlias)
    { case 0: // First language
        return cs.Left(iInd);
      case 1: // Second language
        return cs.Right(cs.GetLength()-iInd-1);
      default:
        return CString("");
    };
}

  /* 
     These two methods is convenient way to access function 
     parameters from SAFEARRAY vector of variants
  */
VARIANT CAddIn::GetNParam(SAFEARRAY *pArray,long lIndex)
{
  ASSERT(pArray);
  ASSERT(pArray->fFeatures | FADF_VARIANT);
  
  VARIANT vt;
  HRESULT hRes = SafeArrayGetElement(pArray,&lIndex,&vt);
  ASSERT(hRes == S_OK);

  return vt;
}

void CAddIn::PutNParam(SAFEARRAY *pArray,long lIndex,VARIANT vt)
{
  ASSERT(pArray);
  ASSERT(pArray->fFeatures | FADF_VARIANT);
  
  HRESULT hRes = SafeArrayPutElement(pArray,&lIndex,&vt);
  ASSERT(hRes == S_OK);
}

/////////////////////////////////////////////////////////////////////////////
// IInitDone

STDMETHODIMP CAddIn::Init(IDispatch *pConnection)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
    
    m_iErrorLog = NULL;
    pConnection->QueryInterface(IID_IErrorLog,(void **)&m_iErrorLog);
    
    CString csProfileName = "AddIn Profile Name";
    m_iProfile = NULL;
    pConnection->QueryInterface(IID_IPropertyProfile,(void **)&m_iProfile);
    m_iProfile->RegisterProfileAs(csProfileName.AllocSysString());

    m_iStatusLine = NULL;
    pConnection->QueryInterface(IID_IStatusLine,(void **)&m_iStatusLine);

    m_iAsyncEvent = NULL;
    pConnection->QueryInterface(IID_IAsyncEvent,(void **)&m_iAsyncEvent);

	// TODO: Add your implementation code here

    if (LoadProperties() == FALSE) return E_FAIL;
    
	return S_OK;
}

STDMETHODIMP CAddIn::Done()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    SaveProperties();

    if (m_iStatusLine) m_iStatusLine->Release();
    if (m_iProfile) m_iProfile->Release();
    if (m_iErrorLog) m_iErrorLog->Release();
    if (m_iAsyncEvent) m_iAsyncEvent->Release();
    
	return S_OK;
}

STDMETHODIMP CAddIn::GetInfo(SAFEARRAY **pInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

      // Component should put supported component technology version 
      // in VARIANT at index 0     
    long lInd = 0;
    VARIANT varVersion;
    V_VT(&varVersion) = VT_I4;
      // This component supports 1.0 version
    V_I4(&varVersion) = 1000;
    SafeArrayPutElement(*pInfo,&lInd,&varVersion);
    
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// ILanguageExtender

STDMETHODIMP CAddIn::RegisterExtensionAs(BSTR *bstrExtensionName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// You may delete next lines and add your own implementation code here

      // Name of extension should be changed avoiding conflicts 
    CString csExtenderName = "AddInExtension";
    *bstrExtensionName = csExtenderName.AllocSysString();

	return NULL;
}

STDMETHODIMP CAddIn::GetNProps(long *plProps)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// You may delete next lines and add your own implementation code here

    *plProps = LastProp;

	return S_OK;
}

STDMETHODIMP CAddIn::FindProp(BSTR bstrPropName,long *plPropNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

    // TODO: Add your implementation code here

	*plPropNum = -1;

    /* 
        Assign proper value to plPropNum if property named bstrPropName is found
    */

    if (*plPropNum == -1) return S_FALSE;

	return S_OK;
}

STDMETHODIMP CAddIn::GetPropName(long lPropNum,long lPropAlias,BSTR *pbstrPropName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
 
    CString csPropName = "";     
    switch(lPropNum)
      { 
        /* 
          Differentiate cases here:
            case Prop1: ...
            case Prop2: ...
             ...
        */
        default:
          *pbstrPropName = csPropName.AllocSysString();
          return S_FALSE;
      }
    
    *pbstrPropName = csPropName.AllocSysString();

	return S_OK;
}

STDMETHODIMP CAddIn::GetPropVal(long lPropNum,VARIANT *pvarPropVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    VariantInit(pvarPropVal);
    switch(lPropNum)
      { 
        /* 
          Differentiate cases here:
            case Prop1: ...
            case Prop2: ...
             ...
        */
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::SetPropVal(long lPropNum,VARIANT *pvarPropVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    switch(lPropNum)
      { 
        /* 
          Differentiate cases here:
            case Prop1: ...
            case Prop2: ...
             ...
        */
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::IsPropReadable(long lPropNum,BOOL *pboolPropRead)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    switch(lPropNum)
      { 
        /* 
          Differentiate cases here:
            case Prop1: ...
            case Prop2: ...
             ...
        */
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::IsPropWritable(long lPropNum,BOOL *pboolPropWrite)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    switch(lPropNum)
      { 
        /* 
          Differentiate cases here:
            case Prop1: ...
            case Prop2: ...
             ...
        */
        default:
          return S_FALSE;
      }

    return S_OK;
}

STDMETHODIMP CAddIn::GetNMethods(long *plMethods)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// You may delete next lines and add your own implementation code here

    *plMethods = LastMethod;

	return S_OK;
}

STDMETHODIMP CAddIn::FindMethod(BSTR bstrMethodName,long *plMethodNum)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	*plMethodNum = -1;

    /* 
        Assign proper value to plMethodNum if method named bstrMethodName is found
    */

    if (*plMethodNum == -1) return S_FALSE;

	return S_OK;
}

STDMETHODIMP CAddIn::GetMethodName(long lMethodNum,long lMethodAlias,BSTR *pbstrMethodName)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    CString csMethodName = "";     
    switch(lMethodNum)
      { 
        /* 
          Differentiate cases here:
            case Method1: ...
            case Method2: ...
             ...
        */
        default:
          *pbstrMethodName = csMethodName.AllocSysString();
          return S_FALSE;
      }
    
    *pbstrMethodName = csMethodName.AllocSysString();

	return S_OK;
}

STDMETHODIMP CAddIn::GetNParams(long lMethodNum,long *plParams)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    *plParams = 0;
    switch(lMethodNum)
      { 
        /* 
          Differentiate cases here:
            case Method1: ...
            case Method2: ...
             ...
        */
        default:
          return S_FALSE;
      }
    
	return S_OK;
}

STDMETHODIMP CAddIn::GetParamDefValue(long lMethodNum,long lParamNum,VARIANT *pvarParamDefValue)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    VariantInit(pvarParamDefValue);
    switch(lMethodNum)
      { 
        /* 
          Differentiate cases here:
            case Method1: ...
            case Method2: ...
             ...
        */
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::HasRetVal(long lMethodNum,BOOL *pboolRetValue)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    switch(lMethodNum)
      { 
        /* 
          Differentiate cases here:
            case Method1: ...
            case Method2: ...
             ...
        */
        default:
          return S_FALSE;
      }

	return S_OK;
}

STDMETHODIMP CAddIn::CallAsProc(long lMethodNum,SAFEARRAY **paParams)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    switch(lMethodNum)
      { 
        /* 
          Differentiate cases here:
            case Method1: ...
            case Method2: ...
             ...
        */
        default:
          return S_FALSE;
      }
    
	return S_OK;
}

STDMETHODIMP CAddIn::CallAsFunc(long lMethodNum,VARIANT *pvarRetValue,SAFEARRAY **paParams)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    switch(lMethodNum)
      { 
        /* 
          Differentiate cases here:
            case Method1: ...
            case Method2: ...
             ...
        */
        default:
          return S_FALSE;
      }

	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// IPropertyPage

STDMETHODIMP CAddIn::SetPageSite(IPropertyPageSite *pPageSite)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
    
    return IPropertyPageImpl<CAddIn>::SetPageSite(pPageSite);
}

STDMETHODIMP CAddIn::Activate(HWND hWndParent,LPCRECT prc,BOOL bModal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    return IPropertyPageImpl<CAddIn>::Activate(hWndParent,prc,bModal);
}

STDMETHODIMP CAddIn::Deactivate()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    return IPropertyPageImpl<CAddIn>::Deactivate();
}

STDMETHODIMP CAddIn::GetPageInfo(PROPPAGEINFO *pPageInfo)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    return IPropertyPageImpl<CAddIn>::GetPageInfo(pPageInfo);
}

STDMETHODIMP CAddIn::SetObjects(ULONG cObjects,IUnknown **ppUnk)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    return IPropertyPageImpl<CAddIn>::SetObjects(cObjects,ppUnk);
}

STDMETHODIMP CAddIn::Show(UINT nCmdShow)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    return IPropertyPageImpl<CAddIn>::Show(nCmdShow);
}

STDMETHODIMP CAddIn::Move(LPCRECT prc)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    return IPropertyPageImpl<CAddIn>::Move(prc);
}

STDMETHODIMP CAddIn::IsPageDirty()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    return IPropertyPageImpl<CAddIn>::IsPageDirty();
}

STDMETHODIMP CAddIn::Apply()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
    
    return IPropertyPageImpl<CAddIn>::Apply();
}

STDMETHODIMP CAddIn::Help(LPCOLESTR pszHelpDir)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

    return IPropertyPageImpl<CAddIn>::Help(pszHelpDir);
}

STDMETHODIMP CAddIn::TranslateAccelerator(LPMSG pMsg)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here
    
    return IPropertyPageImpl<CAddIn>::TranslateAccelerator(pMsg);
}


LRESULT CAddIn::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// TODO: Add your implementation code here

    SetDirty(FALSE);
    m_pPageSite->OnStatusChange(0);
    bHandled = FALSE;

    return 0; 
}

LRESULT CAddIn::OnCommand(WORD wNotifyCode, WORD nID, HWND hWndCtl, BOOL& bHandled)
{
	// TODO: Add your implementation code here

    SetDirty(TRUE);
    bHandled = FALSE;

    return 0;
}
